/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataGoogleClientConfigConfig extends cdktf.TerraformMetaArguments {
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/google-beta/4.81.0/docs/data-sources/google_client_config google_client_config}
*/
export declare class DataGoogleClientConfig extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "google_client_config";
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/google-beta/4.81.0/docs/data-sources/google_client_config google_client_config} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataGoogleClientConfigConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataGoogleClientConfigConfig);
    get accessToken(): string;
    get id(): string;
    get project(): string;
    get region(): string;
    get zone(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
